



use ###base_name###;



create table [FORM]
(
FORM_ID int identity(1,1),
FORM_NAME nvarchar(256),
FORM_YEAR int,
--form_periods nvarchar(256) null,
FORM_DIRECTION nvarchar(32),
FORM_CREATE_DATE datetime,
FORM_DELETE_DATE datetime null default null,
CONSTRAINT [PK_form] PRIMARY KEY (form_ID)

);

create table [ABONENT]
(
ABN_ID int identity(1,1),
ABN_NAME nvarchar(256),
ABN_INN nvarchar(12),

ABN_DELETED datetime,
ABN_SUSPENDED datetime,
ABN_EXT text,
CONSTRAINT [PK_abonent] PRIMARY KEY (abn_ID));

CREATE TABLE [USER_ROLES](
	[ROLE_ID] [int] IDENTITY(1,1) NOT NULL,
	[ROLE_NAME] [varchar](50) NOT NULL,
	[ROLE_DESCRIPTION] [varchar](255) NOT NULL,
	[ROLE_ACTIONS] [nvarchar](4000) NOT NULL,
CONSTRAINT [PK_user_role] PRIMARY KEY (ROLE_ID)
);

create table [USER]
(
USR_ID int identity(1,1),
USR_NAME nvarchar(256),
USR_ABN_ID int not null,
[USR_ROLE_ID] [int] not NULL,
[USR_DELETED] DATETIME,
[USR_LOGIN] NVARCHAR(50),
CONSTRAINT [PK_usert] PRIMARY KEY (usr_ID),
CONSTRAINT [FK_user_abn] FOREIGN KEY (USR_ABN_ID) REFERENCES [ABONENT] (ABN_ID),
CONSTRAINT [FK_user_role] FOREIGN KEY (USR_ROLE_ID) REFERENCES [USER_ROLES] (ROLE_ID)
);



create table [HISTORY]
(
FH_ID int identity(1,1),
FH_FORM_ID int not null,
FH_USR_ID int null,
FH_ABN_ID int not null,
FH_FORM_CODE int not null,
FH_PERIOD nvarchar(15),

FH_DATE datetime,
FH_DATE_DELETE datetime,
FH_CORR int,

CONSTRAINT [PK_history] PRIMARY KEY (fh_ID),
CONSTRAINT [FK_history_form] FOREIGN KEY (fh_form_id) REFERENCES [form] (form_id),

CONSTRAINT [FK_history_abonent] FOREIGN KEY (fh_abn_id) REFERENCES [abonent] (abn_id),
CONSTRAINT [FK_history_user] FOREIGN KEY (fh_usr_id) REFERENCES [user] (usr_id));

create table [LASTCORR]
(
CORR_ID int identity(1,1),
CORR_FORM_ID int not null,
CORR_ABN_ID int not null,
CORR_USR_ID int null,
CORR_PERIOD nvarchar(15),
CORR_VALUE int not null,
CONSTRAINT [PK_corr] PRIMARY KEY (corr_ID),
CONSTRAINT [FK_corr_form] FOREIGN KEY (corr_form_id) REFERENCES [form] (form_id),
CONSTRAINT [FK_corr_abn] FOREIGN KEY (corr_abn_id) REFERENCES [abonent] (abn_id),
CONSTRAINT [FK_corr_usr] FOREIGN KEY (corr_usr_id) REFERENCES [user] (usr_id));


create table [LOG]
(
LOG_ID int identity(1,1),
LOG_ABN_ID int not null,
LOG_FORM_ID int not null,
LOG_USER_ID int null,
LOG_ACTION nvarchar(32),
LOG_DATE datetime,
LOG_EXT nvarchar(512),
CONSTRAINT [PK_LOG] PRIMARY KEY (LOG_ID)
,CONSTRAINT [FK_log_form] FOREIGN KEY (LOG_FORM_ID) REFERENCES [form] (form_id)
,CONSTRAINT [FK_log_abn] FOREIGN KEY (LOG_ABN_ID) REFERENCES [abonent] (abn_id)
,CONSTRAINT [FK_log_user] FOREIGN KEY (LOG_USER_ID) REFERENCES [USER] (USR_ID)
);



--пока не используется
create table [REF]
(
REF_TYPE nvarchar(32),
REF_KEY nvarchar(32),
REF_VAL nvarchar(2048));

create table [FILESTORE]
(
FS_ID int identity(1,1),
FS_BODY image,
FS_SIZE bigint,
CONSTRAINT [PK_filestore] PRIMARY KEY (fs_ID)
--,CONSTRAINT [FK_history_filestore] FOREIGN KEY (fs_id) REFERENCES [history] (fh_form_code)
);

CREATE TABLE [DOC_BLOCKINGS](
	[BLK_ID] [int] IDENTITY(1,1) NOT NULL,
	[BLK_DOC_ID] nvarchar(100) NOT NULL,
	[BLK_USER_ID] [int] NOT NULL,
	[BLK_TIME] [datetime] NOT NULL,
	[BLK_OPERATION] [nvarchar](50) NOT NULL,
	CONSTRAINT [PK_blk] PRIMARY KEY (BLK_ID)
	,CONSTRAINT [FK_block_user] FOREIGN KEY (BLK_USER_ID) REFERENCES [USER] (USR_ID)
);

create table [ver]
(

ver_value nvarchar(16)


);

insert into [ver](ver_value) values('1.0');
insert into [USER_ROLES](ROLE_NAME,ROLE_ACTIONS,ROLE_DESCRIPTION) values('Сисадмин', 'ADMIN', 'Администратор');
insert into [USER_ROLES](ROLE_NAME,ROLE_ACTIONS,ROLE_DESCRIPTION) values('Пользователь', 'USER', 'Простой пользователь');

--insert into [user](usr_name, usr_abn_id, usr_role_id,usr_login) values ('Первичный пользователь',1,1,'sa')
--insert into [user](usr_name, usr_abn_id, usr_role_id,usr_login) values ('Первичный пользователь',2,1,'sa')

--xxxxxxxxxxxxxxxxxxxxxxxxxxxx

CREATE ROLE [UchetUser] AUTHORIZATION [dbo];


GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[ABONENT] TO [UchetUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[DOC_BLOCKINGS] TO [UchetUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[FILESTORE] TO [UchetUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[FORM] TO [UchetUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[HISTORY] TO [UchetUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[LASTCORR] TO [UchetUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[LOG] TO [UchetUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[REF] TO [UchetUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[USER] TO [UchetUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[VER] TO [UchetUser];
GRANT DELETE, INSERT, SELECT, UPDATE ON [dbo].[USER_ROLES] TO [UchetUser];
--GRANT DELETE, INSERT, SELECT, UPDATE ON [UchetUserSchema].[ABONENT] TO [UchetUser]





